# ==================================================================
# Plugins::Community::Tables - Auto Generated Program Module
#
#   Plugins::Community::Tables
#   Author  : Jonathan Gamble
#   Version : 3.0
#   Updated : Mon Oct 15 22:20:43 2007
#
# ==================================================================
#

package Plugins::Community::Tables;
# ==================================================================

    use strict;
    use GT::Base;
    use vars qw/$TCFG $template_set/;
    use GT::Plugins qw/STOP CONTINUE/;
    use Community qw/$CFG $IN $DB/;

    use Community::Web::Plugins;
    use IO::Dir;

	$TCFG = Community::Web::Plugins::get_plugin_user_cfg('Tables');
	$template_set = $CFG->{system_template_set};

# Inherit from base class for debug and error methods
    @Plugins::Community::Tables::ISA = qw(GT::Base);

sub tables_admin {
# ---------------------------------------------------

# Process Tables Admin

	my $do = $IN->param('do') || '';

# Determine what to do

	return create_form() if ($do eq 'create_form');
	return create_table() if ($do eq 'create_table');
	return drop_table() if ($do eq 'drop_table');
	return index_editor() if ($do eq 'index_editor');
	return adv_editor() if ($do eq 'adv_editor');

	use GT::SQL::Admin;

    my $admin = new GT::SQL::Admin;
    if ($admin->for_me($IN)) {
		print $IN->header;
        $admin->process(db => $DB, cgi => $IN);
		my $table = $IN->param('db');
    	print "<br><font face=arial size=2><a href=$CFG->{path_cgi_url}?do=admin_plugin&plugin=Tables&func=tables_menu>Tables Plugin</a> | ";
		print "<a href=$CFG->{path_cgi_url}?do=admin_plugin&plugin=Tables&func=adv_editor&db=$table>Advanced Editor</a> | ";
        print "<a href=$CFG->{path_cgi_url}?do=admin_home&pg=admin_plugin.html>Plugins Home</a></font>";
		return;
    }
	return tables_menu();

}

sub tables_menu {
# ---------------------------------------------------

# Print Tables Menu

    my (@tables, %records);
    my $sb = $IN->param('sb') || '';
    my $so = $IN->param('so') || '';

	my @tables = get_tables($TCFG->{Path});

# get the number of records for each table

    foreach (@tables) { 
        $records{$_} = $DB->table($_)->count() || '0';
    }

# go through each record and sort as needed

	my $tables;
    
    foreach my $key (sort {

        if ($sb eq 'records') {
            return ($records{$b} cmp $records{$a}) if ($so eq 'DESC'); 
            return ($records{$a} cmp $records{$b});
        }
        else {
            return $b cmp $a if ($so eq 'DESC');
            return $a cmp $b;
        }

        } keys %records) {

            $CFG->{table_name} = $key;

            $CFG->{hits} = $records{$key};

            $tables .= GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_table.html', $CFG);

    }

# create tags opposite to the current sort

    if ($IN->param('so') eq 'ASC') {
        $TCFG->{so} = 'DESC';
    }
    else { $TCFG->{so} = 'ASC'; }

    $TCFG->{tables} = \$tables;


# print the template

	GT::Plugins->action (STOP);

	return ('admin_tables_menu.html', $TCFG);

}
sub create_form {
# ---------------------------------------------------

    my ($tags);
    my $template_set = $CFG->{system_template_set};

    $tags->{num_columns} = $IN->param('fields');
    $tags->{table_name} = $IN->param('tablename');

    print $IN->header;

    for (my $c = 1; $c <= $tags->{num_columns}; $c++) {

        $tags->{column} = $c;

        print GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_create_form.html', $tags);
						
    }

    
}

sub create_table {
#---------------------------------------------------
#
# create the table and the first field

	my $c = $DB->creator($IN->param('tablename'));

	my $i = 1;

	my @values1 = split(/\s+/, $IN->param('values1'));
	my @form_names1 = split(/\s+/, $IN->param('form_names1'));
		
	$c->cols($IN->param('column'.$i) => {
		pos => $i,
        type => $IN->param('type'.$i),
        size => $IN->param('size'.$i),
		values => \@values1,
		not_null => $IN->param('not_null'.$i),
		default => $IN->param('default'.$i),
		form_display => $IN->param('form_display'.$i),
		form_type => $IN->param('form_type'.$i),
		form_size => $IN->param('form_size'.$i),
		form_names => \@form_names1,
		file_save_in => $IN->param('file_save_in'.$i),
		file_save_url => $IN->param('file_save_url'.$i),
		file_save_scheme => $IN->param('file_save_scheme'.$i),
		file_max_size => $IN->param('file_max_size'.$i),
		regex => $IN->param('regex'.$i)

	});

    $c->create or die "Unable to create: $GT::SQL::error";

# create the rest of the fields

	my $e = $DB->editor($IN->param('tablename'));

	for (my $i=2; $i <= $IN->param('fields'); $i++) {	

		my @values = split(/\s+/, $IN->param('values'.$i));
		my @form_names = split(/\s+/, $IN->param('form_names'.$i));

		$e->add_col($IN->param('column'.$i) => {
		pos => $i,
        type => $IN->param('type'.$i),
        size => $IN->param('size'.$i),
		values => \@values,
		not_null => $IN->param('not_null'.$i),
		default => $IN->param('default'.$i),
		form_display => $IN->param('form_display'.$i),
		form_type => $IN->param('form_type'.$i),
		form_size => $IN->param('form_size'.$i),
		form_names => \@form_names,
		file_save_in => $IN->param('file_save_in'.$i),
		file_save_url => $IN->param('file_save_url'.$i),
		file_save_scheme => $IN->param('file_save_scheme'.$i),
		file_max_size => $IN->param('file_max_size'.$i),
		regex => $IN->param('regex'.$i)

		}) or die "Unable to add column: $GT::SQL::error";

	}

	$TCFG->{message} = "The table " . $IN->param('tablename') . " was created successfully!";

        tables_menu();

}

sub drop_table {
#---------------------------------------------------
#
    if ($IN->param('drop_confirm') eq 'yes') {
		my $c = $DB->creator($IN->param('table_name'));
		$c->drop_table or die "Unable to drop: $GT::SQL::error";
        $TCFG->{message} = "The table " . $IN->param('table_name') . " was dropped successfully!";
        tables_menu();
    } elsif ($IN->param('drop_confirm') eq 'no') {
        $TCFG->{message} = "The table " . $IN->param('table_name') . " was NOT dropped!";
        tables_menu();
    } else {
        print $IN->header;
		GT::Plugins->action (STOP);
        return ('admin_tables_drop_form.html', $IN);
    }
}

sub adv_editor {
#---------------------------------------------------
#
	my $table = $IN->param('db');
	return if (!$table);
	# check for adding keys
	if ($IN->param('add_pk')) {
		add_key(1, 'PRIMARY', $IN->param('add_pk'));
	}
	if ($IN->param('add_unique')) {
		add_key($IN->param('add_unique'), 'UNIQUE', $IN->param('add_unique'));
	}
	if ($IN->param('add_index')) {
		add_key($IN->param('add_index'), 'INDEX', $IN->param('add_index'));
	}
	# get the table information
	my $tb = load_config($IN->param('db'));
	# protect columns from editing
    if ($IN->param('allow')) {
		$tb->{cols}->{$IN->param('allow')}->{protect} = undef;
		$tb->save;
	}
	if ($IN->param('protect')) {
		$tb->{cols}->{$IN->param('protect')}->{protect} = 1;
		$tb->save;
	}
	# auto increment
	if ($IN->param('add_ai')) {
		my $sth = $DB->table($table);
		$sth->do("ALTER TABLE ".$table." CHANGE ".$IN->param('add_ai')." ".$IN->param('add_ai')." INT NULL AUTO_INCREMENT") or die $GT::SQL::error;
		$tb->{ai} = $IN->param('add_ai');
		$tb->save;
	}
	if ($IN->param('drop_ai')) {
		my $sth = $DB->table($table);
		$sth->do("ALTER TABLE ".$table." CHANGE ".$IN->param('drop_ai')." ".$IN->param('drop_ai')." INT") or die $GT::SQL::error;
		$tb->{ai} = undef;
		$tb->save;
	}	
	# check for dropping keys
	if ($IN->param('drop_pk')) {
		my $e = $DB->editor($table);
		$e->drop_pk or die "Unable to drop primary key: $GT::SQL::error";
		$tb->{pk} = []; # take care of editor.pm bug with drop_pk
		$tb->save;
	}
	if ($IN->param('drop_unique')) {
		my $e = $DB->editor($table);
		$e->drop_unique($IN->param('drop_unique')) or die "Unable to drop unique key: $GT::SQL::error";
	}
	if ($IN->param('drop_index')) {
		my $e = $DB->editor($table);
		$e->drop_index($IN->param('drop_index')) or die "Unable to drop index: $GT::SQL::error";
	}
	if ($IN->param('drop_fk')) {
		my $e = $DB->editor($table);
		$e->drop_fk($IN->param('drop_fk')) or die "Unable to drop foreign key: $GT::SQL::error";
	}
	# change the position if necessary
	if ($IN->param('up') && $IN->param('down')) {
		my $up = $tb->{cols}->{$IN->param('up')}->{pos};
		my $down = $tb->{cols}->{$IN->param('down')}->{pos};
		# switch the numbers
		$tb->{cols}->{$IN->param('up')}->{pos} = $down;
		$tb->{cols}->{$IN->param('down')}->{pos} = $up;
		$tb->save;
	}
	# get indexes
	my @pks = @{$tb->{pk}};
	my @columns = keys %{$tb->{cols}};
	my @uniques = keys %{$tb->{unique}};
	my @indexes = keys %{$tb->{index}};
	my @fk_tables = @{$tb->{fk_tables}};
	my @fks = keys %{$tb->{fk}};
	my $keys;
	my $num_keys = scalar(@uniques)+scalar(@indexes)+scalar(@fks);
	$num_keys++ if (@pks);
	my $K;
	my $n = 1;
	# print each index
	$K->{table} = $table;
	foreach (@uniques) {
		$K->{first} = 1 if ($n == 1);
		$K->{last} = 1 if ($n == $num_keys);
		$K->{keyname} = $_;
		$K->{type} = "UNIQUE";
		$K->{fields} = \@{$tb->{unique}->{$_}};
		$keys .= GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_adv_keys.html', $K);
		$K->{first} = undef;
		$n++;
	}
	foreach (@indexes) {
		$K->{first} = 1 if ($n == 1);
		$K->{last} = 1 if ($n == $num_keys);
		$K->{keyname} = $_;
		$K->{type} = "INDEX";
		$K->{fields} = \@{$tb->{index}->{$_}};
		$keys .= GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_adv_keys.html', $K);
		$K->{first} = undef;
		$n++;
	}
	foreach (@fks) {
		$K->{first} = 1 if ($n == 1);
		$K->{last} = 1 if ($n == $num_keys);
		$K->{keyname} = $_;
		$K->{type} = "FOREIGN";
		my @fs;
		foreach my $fk (keys %{$tb->{fk}->{$_}}) {
			push(@fs, $fk." => ".$tb->{fk}->{$_}->{$fk});
		}
		$K->{fields} = \@fs;
		$keys .= GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_adv_keys.html', $K);
		$K->{first} = undef;
		$n++;
	}
	if (@pks) {
		$K->{first} = 1 if ($n == 1);
		$K->{last} = 1 if ($n == $num_keys);
		$K->{keyname} = "PRIMARY";
		$K->{type} = "PRIMARY";
		$K->{fields} = \@{$tb->{pk}};
		$keys .= GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_adv_keys.html', $K);
	}
	# put the positions in an array
	my %pos;
	foreach (@columns) {
		$pos{$_} = $tb->{cols}->{$_}->{pos};
	}
	# sort by position
	my $c = 0;
	my @pos = sort {$pos{$a} cmp $pos{$b}} keys %pos;	
	my $cols;
	foreach my $key (@pos) {
	# get the columns of interests
		if ($c == 0) {
			$CFG->{first} = 1;
		} else {
			$CFG->{before} = $pos[$c-1];
		}
		if ($c == scalar(@columns)-1) {
			$CFG->{last} = 1;
		} else {
			$CFG->{after} = $pos[$c+1];
		}
		# sort out indexes
		foreach (@pks) {
			$CFG->{pk} = $key if ($_ eq $key);
		} foreach (@uniques) {
			$CFG->{unique} = $key if ($_ eq $key);
		} foreach (@indexes) {
			$CFG->{index} = $key if ($_ eq $key);
		}
		$CFG->{ai} = $key if ($key eq $tb->{ai});
		$CFG->{protect} = 1 if ($tb->{cols}->{$key}->{protect});
		$CFG->{column} = $key;
		$CFG->{table} = $table;
 		$cols .= GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_adv_table.html', $CFG);
		# reset to null for template
		$CFG->{first} = undef;
		$CFG->{pk} = undef;
		$CFG->{unique} = undef;
		$CFG->{index} = undef;
        $CFG->{protect} = undef;
		$c++;
	}
# print the template
	$TCFG->{keys} = \$keys;
	$TCFG->{columns} = \$cols;
	$TCFG->{table} = $table;
	GT::Plugins->action (STOP);
	return ('admin_tables_adv.html', $TCFG);
}

sub index_editor {
#---------------------------------------------------
# Displays the create index page

	my $template_set = $CFG->{system_template_set};
	my $table = $IN->param('db');
	return tables_menu() if (!$table);

	# load the definitions

	my $tb = load_config($table);

	# create new keys

	if ($IN->param('save')) {
		my $type = $IN->param('index_type');
		my $name = $IN->param('index_name');
		my @fields = split_input("field_", keys %{$tb->{cols}});
		return adv_editor() if (!$type or !@fields);
		if ($type eq 'FOREIGN') {
			my ($fkTable, $fkPk) = split(/ -> /, $IN->param('fk'));
			$DB->editor($table)->add_fk($fkTable, { $fields[0] => $fkPk });
		} else { add_key($name, $type, @fields); }
		return adv_editor();
	}
	# get pks for FOREIGN types
	my @tables = get_tables($TCFG->{Path});
	my @pks;
	print $IN->header;
	foreach my $t (@tables) {
		next if ($table eq $t);
		my $c = load_config($t);
	# get the pks from each table
		foreach (@{$c->{pk}}) {
			push (@pks, $t." -> ".$_);
		}
	}
	# create the form fields
	my @selected = split_input("select_", keys %{$tb->{cols}});
	return adv_editor() if (!@selected);
	my $num_fields = scalar(@selected);

	my ($fields, $col);
	while ($num_fields > 0) {
		$CFG->{field} = $selected[$num_fields-1];
		$CFG->{first} = 1 if ($num_fields == scalar(@selected));
		$CFG->{last} = 1 if ($num_fields == 1);
		$CFG->{count} = $num_fields;
		$fields .= GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_adv_fields.html', $CFG);
		$num_fields--;
		$CFG->{first} = undef;
	}

	GT::Plugins->action(STOP);
	$TCFG->{pks} = \@pks;
	$TCFG->{fields} = \$fields;
	$TCFG->{table} = $IN->param('db');
	$TCFG->{num_columns} = scalar(@selected);

	return ('admin_tables_adv_create.html', $TCFG);

}

sub split_input {
#---------------------------------------------------
# Splits an input array

	my ($prefix, @input_array) = @_;

	my @output;

	foreach (@input_array)
	{
		push (@output, $_) if ($IN->param($prefix.$_));

	}
	return @output;

}

sub add_key {
#---------------------------------------------------
# Add a new index to the table

	my $e = $DB->editor($IN->param('db'));

	my ($name, $type, @fields) = @_;

	if ($type eq 'PRIMARY') {
		$e->add_pk(@fields) or die "Unable to add primary key: $GT::SQL::error";
	}
	if ($type eq 'UNIQUE') {
		$e->add_unique($name => \@fields) or die "Unable to add unique key: $GT::SQL::error";
	}
	if ($type eq 'INDEX') {
		$e->add_index($name => \@fields) or die "Unable to add index: $GT::SQL::error";
	}
	return;

}

sub load_config {
#---------------------------------------------------
# Loads the config for the current table
	
	my $db = shift;

    use GT::Config;
	
    my $pre = $DB->prefix(); # db prefix
    return GT::Config->load($CFG->{path_private}."/defs/".$pre.$db."\.def");

}

sub get_tables {
#---------------------------------------------------
# Returns all the table names

	my $defPath = shift;
    my $d = IO::Dir->new($defPath) || die "Could not open dirhandle! $!\n";
    my $pre = $DB->prefix();    # db prefix
    my $i = 0;
	my @tables;

# get the table names

    while (defined(my $file = $d->read)) {

# Hide GT Tables

        if ($file ne '.' && $file ne '..' && $file ne 'database.def') {
	    $file =~ s/.def//;
            $file =~ s/$pre//;
            push(@tables, $file);     
        }
        $i++;
    }
	return @tables;

}


# Always end with a 1.
1;