#!/usr/bin/perl
# ==================================================================
# cgi::tables - used by the tables plugin
#
#   Plugins::tables
#   Author  : Jonathan Gamble
#   URL     : http://www.magicdirectory.com
#   Version : 2.0
#   Updated : Sept 20 2006
#
# ==================================================================
#

use strict;
use lib '/home/httpd/vhosts/jonathangamble.com/private/lib';
use Community qw/comm_init comm_config comm_fatal $IN $CFG/;
use GT::CGI;
use GT::Plugins;

use Carp;

local $SIG{__DIE__} = \&fatal;
# local $SIG{__WARN__} = \&fatal;

Community::init('/home/httpd/vhosts/jonathangamble.com/private');

&main;

sub main {

# Make sure Admin is logged in
	
	my $cfg  = comm_config();
	my $pass = $IN->cookie('Community_Admin_Pass');

	if (!$cfg->{system_setup} or ($pass and ($pass eq $cfg->{admin_password}))) {

		require Community::Web::Admin;	          
		require Plugins::Community::Tables;

		my ($page, $vars) = Plugins::Community::Tables::tables_admin();

		Community::Web::Admin::admin_page($page, $vars) if ($page);
        
	}

	else {

		require Community::Web::User;

        GT::Plugins->dispatch(
                $CFG->{path_private} . '/lib/Plugins/Community', 
                'user_process',
                sub { Community::Web::User::process(@_) },
                'user_home'
        );
	}

}

sub fatal {
# -------------------------------------------------------------------
    die @_ if (GT::Base->in_eval());    # Don't do anything if we are in eval.

    my $in = new GT::CGI;
    my $error = shift;
    $error .= "\nGT::SQL::error => $GT::SQL::error\n" if ($GT::SQL::error);

    print $in->header;
    my $default = <<END_OF_HTML;
<html>
<head>
<title>Error</title>
</head>
<body>
The system encountered a fatal error:
<pre><%error%></pre>
</body>
</html>
END_OF_HTML
    my $msg = $CFG->{system_error_msg} || $default;
    $msg =~ s,<%error%>,$error,g;
    print $msg;
}
